Subject: Re: bug#37926: [PATCH] Unify Gnus select methods

From: Eric Abrahamsen <[email-masked]>
Date: Sat, 02 Nov 2019 14:10:40 -0700

On 11/02/19 16:52 PM, Deus Max wrote:
> On Sat, Nov 02 2019, [email-masked] wrote:
>
>> One, to reiterate, the patch at hand is a useability improvement, protecting new users from
>> the byzantine distinction of primary/secondary, and preserving the distinction
>> internally for backwards compatibility.  Some have argued keeping the internal
>> distinction makes the patch unworthy of the risk, to which I am sympathetic.
>>
> You agree it is a usability improvement and that the current behaviour is
> a byzantine distinction.
> Sometimes to move forward, you have to break continuity.
> Especially with byzantine practises, old OSes, etc., etc.
>
>> Two, with mild effort, I could fully eliminate the distinction without user
>> guidance or manually rewriting newsrcs.  Such a change exacerbates risk.
>
> Which is probably not mild. As you will discover from the many-many bugs
> that follow.

A while ago I worked on a patch that removed the distinction altogether.
I just assumed that the first method in `gnus-select-methods' should be
treated specially, and all unprefixed groups were assigned to that
method at load time. That part wasn't hard. Then each method had a
"display prefix" parameter, which defaulted to the name of the method
except for the first method, where it defaulted to the empty string.
Group names stayed fully prefixed everywhere in the system, and were
only displayed differently.

I was actually happier with getting rid of the
is-the-group-name-prefixed-or-not logic all over Gnus than I was with
reducing user confusion with two select method options.

But there's a lot of very fundamental code that wants
`guns-select-method' to be set, and I eventually got bogged down with
that. I still think it's worth doing, though.

Eric